﻿namespace ErrorPropertyIssueForInfragistics
{
	using System;
	using System.ComponentModel;

	public class FactorRow
	{
		// this represents a row of data to be displayed in the grid - the number of Factors in the array can vary

		public string Name { get; set; }
		public Factor[] Factors { get; set; }
	}

	public class Factor : IDataErrorInfo, INotifyPropertyChanged
	{
		private double factorValue;

		public double FactorValue
		{
			get
			{
				return this.factorValue;
			}
			set
			{
				if (this.factorValue != value)
				{
					this.factorValue = value;
					if (this.PropertyChanged != null)
					{
						this.PropertyChanged(this, new PropertyChangedEventArgs("FactorValue"));
					}
				}
			}
		}
		#region IDataErrorInfo implementation

		public string Error
		{
			get
			{
				return string.Format("Factor value {0} is in error.", this.FactorValue);
			}
		}

		public string this[string columnName]
		{
			get { throw new NotImplementedException(); }
		}
		#endregion IDataErrorInfo implementation

		public event PropertyChangedEventHandler PropertyChanged;
	}
}
